// $scope, $element, $attrs, $injector, $sce, $timeout, $http, $ionicPopup, and $ionicPopover services are available
//======================================
$scope.app.isIOS=function() { 
    if(!window.twx.app.isPreview()) // is not in Preview
       if(ionic.Platform.isIOS()) //and is NOT called on IOS = means Android mode detected
         return true;
   return false; }
//======================================
$scope.app.isPreview=function() { 
    if(window.twx.app.isPreview()) // is in Preview
         return true;
   return false; }
//======================================
$scope.app.isAndroid=function() { 
    if(!window.twx.app.isPreview()) // is not in Preview
      if(/android/i.test(navigator.userAgent || navigator.vendor || window.opera) ) // is Android
         return true;
   return false; }
//======================================
$scope.app.isWinPhone=function() { 
    if(!window.twx.app.isPreview()) // is not in Preview
      if(/windows phone/i.test(navigator.userAgent || navigator.vendor || window.opera) ) // is Android
         return true;
   return false; }
//======================================
$scope.app.isWindow=function() { 
    if(!window.twx.app.isPreview()) // is not in Preview
       if( navigator.platform.indexOf("Win32") >- 1) // is this WindowsPhone
         return true;
     return false; }
//========================================
angular.element(document).ready(function () {
  console.warn($scope)
  console.warn($rootScope)
   

if($scope.app.isPreview()) 
 { $scope.setWidgetProp('label-3',  'text',  "PREVIEW MODE");
    twx.app.fn.addSnackbarMessage("PREVIEW MODE","twLogo"); }
else if($scope.app.isIOS()){
  	$scope.setWidgetProp('label-3',  'text',  "called on IOS Device");
  twx.app.fn.addSnackbarMessage("called on IOS Device","twLogo"); }
else if($scope.app.isAndroid()) {
  $scope.setWidgetProp('label-3',  'text',  "called on Android Device");
  twx.app.fn.addSnackbarMessage("called on Android Device","twLogo"); }
else if($scope.app.isWindow()) {
  $scope.setWidgetProp('label-3',  'text',  "called on Window Plattform");
  alert("called on Windows Phone Device"); }

  //$scope.setWidgetProp('label-3',  'text',  navigator.platform.toString())
if($scope.app.isPreview())  
   twx.app.fn.addSnackbarMessage("PREVIEW MODE","twLogo"); 
  else
  {
     
     $timeout(twx.app.fn.addSnackbarMessage("navigator.platform="+navigator.platform,"twLogo"),3000); //after 3 sec
    
     $timeout(twx.app.fn.addSnackbarMessage("getMobileOperatingSystem()="+getMobileOperatingSystem(),"twLogo"),6000); //after 5 sec
    
     $timeout(twx.app.fn.addSnackbarMessage("getPlatform()="+getPlatform(),"twLogo"),9000); //after 5 sec

  }
  
  //===========================================================
 angular.element(window).on('resize', function(evt) {
   console.log("resized window evnt : at Time ::"+$scope.getTime());
   console.warn(evt);
    var message = ''
      var win = evt.path[0];
      if(win.innerWidth > win.innerHeight){
          // LANDSCAPE -> do something here call your landscapeFunc()
          message = "current orientation is Landscape!"
        $scope.$applyAsync();
      }
      else {
           // LANDSCAPE -> do something here your PortraitFunc()
          message = "current orientation is Portrait!"     
        $scope.app.params['myClass']='row3'
        $scope.$applyAsync();
          }
     twx.app.fn.addSnackbarMessage(message,"twLogo");
    
    });
 
  $scope.app.setButtonInfo('Events',
         'This will start the chapter for Widget Events and Services',
                           'textArea-1')
  $scope.app.setButtonInfo('ApplicationParameters',
         'This will start the chapter for Applicaiton Parameters and Filters',
                           'textArea-1')
 
  $scope.app.setButtonInfo('JsFunctions',
         'This will start the chapter for JavaScript Functions',
                           'textArea-1')
  $scope.app.setButtonInfo('TryCatch',
         'This will start the chapter for Try and Catch in JavaScript',
                           'textArea-1')
  $scope.app.setButtonInfo('Debugging',
         'This will start the chapter for Debugging demo',
                           'textArea-1')
  $scope.app.setButtonInfo('RemoteControlDemo',
         'This will start the view where the script to this training is implemented',
                           'textArea-1')
 
});
//=================================================================================================
$scope.app.setButtonInfo=function (widget_name,info,info_widget) {
var wdg_button = angular.element(document.querySelector('twx-widget[widget-id=\"'+widget_name+'\"] button'));

  //------------------
  wdg_button[0].onmouseover=function(){   
   console.warn("WIDGET["+widget_name+"].onmouseover");
   $scope.setWidgetProp(info_widget, 'text',info);  
   $timeout(
     $scope.setWidgetProp(info_widget, 'class','ptc-3DLabel3')
            ,200)
   $scope.$applyAsync();
                                           };
   //------------------
   wdg_button[0].onmouseleave=function(){   
   console.warn("WIDGET["+widget_name+"].onmouseleave"); 
     
   //$scope.setWidgetProp(info_widget, 'class','ptc-3DLabel1');
   $scope.setWidgetProp(info_widget, 'text', " no button selected");
   $timeout(
      
     $scope.setWidgetProp(info_widget, 'class','ptc-3DLabel1')
            ,200);  
   $scope.$applyAsync();
                                           };      
      
}
   
//=================================================================================================
$scope.getTime = function() {
var date = new Date();
var h = date.getHours(); // 0 - 23
var m = date.getMinutes(); // 0 - 59
var s = date.getSeconds(); // 0 - 59
var session = "AM";
if(h == 0){h = 12;}
if(h > 12){h = h - 12;session = "PM";}
h = (h < 10) ? "0" + h : h;
m = (m < 10) ? "0" + m : m;
s = (s < 10) ? "0" + s : s;
var time = h + ":" + m + ":" + s + " " + session;
return time;
}
//===============================================================================================