// $scope, $element, $attrs, $injector, $sce, $timeout, $http, $ionicPopup, and $ionicPopover services are available


//=================================================================================================
//Global Variables			
var pjson ="properties.json"; //JSON File start properties ->Name without extension
var stepsjson ="steps.json"; //JSON File start properties ->Name without extension
//=================================================================================================
$scope.jsonData_props={}; //global $scope variable
$scope.jsonData_steps={}; //global $scope variable

gotJSON=function(data){
 try{
$scope.jsonData_props=JSON.parse(data);
 console.warn(  JSON.stringify($scope.jsonData_props))
   $scope.setMutipleProps($scope.jsonData_props)
 } 
catch(wrong){    console.warn(wrong);}

}
//=================================================================================================
doRead=function (jsonFile){
fetch(jsonFile)
  .then(response=>response.text())
  .then(data=>gotJSON(data))
}
//==================================
readSteps=function (jsonFile){
  console.warn("**=>readSteps :: "+jsonFile);
fetch(jsonFile)
  .then(response=>response.text())
  .then(data=>{$scope.jsonData_steps=JSON.parse(data);
                             console.warn(  JSON.stringify($scope.jsonData_steps))})
  .catch((wrong) => {console.log("problem in fetch: "); console.warn(wrong)})
}
//==================================

$scope.Init=function() {
doRead('app/resources/Uploaded/'+pjson);
$timeout(readSteps('app/resources/Uploaded/'+stepsjson),200);
}
//=================================================================================================
// EVENTS
//====================================================stepsjson=============================================
//   modelLoaded  -> this event fires when model was loaded successfuly
//=================================================================================================
$rootScope.$on('modelLoaded', function() {
  console.log("modelLoaded event");
   const args = Array.from(arguments);
 
  for( let  i=0;i< args.length;i++ )   
    console.log("Event args["+i+"]="+args[i])

 
  // $scope.setWidgetProp('3DLabel-1','visible',true);
 
  //update the display
  $scope.$applyAsync();

})
//=================================================================================================
//   $ionicView.afterEnter -> this event fires when 2d view was entered
//=================================================================================================
$scope.$on('$ionicView.afterEnter',function(){
  console.log("$ionicView.afterEnter was called");
$scope.Init();}) //event: when 2d View loaded
//the code will read the complette JSON File and
//assignee it to a jsonData global variable
//func will set mutliple widget properties according JSON
$scope.setMutipleProps  = function(obj){

 Object.keys(obj).forEach(function (item)  {
                for(var prop in obj[item])    {
                           $scope.view.wdg[item][prop]=obj[item][prop];  
                           //print the setting for debugging                 
							console.log("==>$scope.view.wdg["+item+"]["+prop+"]="+obj[item][prop] )
                                              } 
                							})
                  $scope.$applyAsync();  };
                  
 
///=================================================================================================
//  stepcompleted -> this event fires sequence sdtep was finished
//=================================================================================================
$scope.$on('stepcompleted', function(evt, arg1, arg2, arg3) { 
 var parsedArg3 = JSON.parse(arg3);
  //console.warn(arg3)
console.log("stepcompleted stepNumber="+parsedArg3.stepNumber + "  nextStep="+parsedArg3.nextStep);
  $scope.$applyAsync(()=>{ 
                         // $scope.setWidgetProp('label-1', 'text',""+ JSON.parse(arg3)) 
                          // $scope.app.params['disabled']="false";
                         })
 
}); 
//=================================================================================================
//   stepstarted  -> this event fires step was started
//=================================================================================================
//  $scope.$applyAsync(()=>{ $scope.setWidgetProp(modelWdgName, 'disabled',false) })
$scope.$on('stepstarted', function(evt, arg1, arg2, arg3) { 
 var parsedArg3 = JSON.parse(arg3);
  //console.warn(arg3)
console.log("stepstarted stepNumber="+parsedArg3.stepNumber + "  nextStep="+parsedArg3.nextStep);
$timeout(()=>{ $scope.setMutipleProps($scope.jsonData_steps[parsedArg3.stepNumber.toString()])},10)
$scope.setWidgetProp('label-1', 'text',"STEP: "+ parsedArg3.stepNumber) 
  $scope.$applyAsync();
 
}); 
//=================================================================================================